Unit DE92R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE84RJ_p, DE92RS_p, UTDE20_p;

procedure DE92R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var A :Array of Real; var A1 :Array of Real;
                var A2 :Array of Real; var RAB :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var YD :Array of Real; var IERR :Integer);

implementation

procedure DE92R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var A :Array of Real; var A1 :Array of Real;
                var A2 :Array of Real; var RAB :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var YD :Array of Real; var IERR :Integer);
var
I,I1,I2,I3 :Integer;
EPS1,EPSJ,HS,XT :Real;
BULD,BULHM :Boolean;
const
EPS0 :Real = 1.0E-5;
label
_2,_3,_8,_9,_18,_19,_80,_85,_100,_105,_106,_110,_130;
begin
{   BOHEHE OHOO AA  ABTOHOMHO CCTEM C KOHTPOEM }
{   TOHOCT O PABY PYHE C BCEHEM MATP KO }
{   METOOM PAHOCTHX OTHOEH. }
IERR := 0;
BULD := True;
BULHM := False;
if ( JSTART ) < 0
 then goto _2
 else if ( JSTART ) > 0
       then goto _8
       else goto _8;
_2:
for I:=1 to M do
 begin
_3:
  YX[I-1] := YP[I-1];
 end;
X := XP;
_8:
EPS1 := EPS/32.0;
EPSJ := EPS;
if ( EPS < EPS0 ) 
 then goto _9;
EPSJ := EPS0;
_9:
I1 := 1 + M;
I2 := I1 + M;
I3 := I2 + M;
DE84RJ (F,X,YX,A,M,EPSJ,RAB[0],RAB[I1-1]);
_18:
DE92RS (F,M,YX,X,A,H,R2,RAB[0],RAB[I1-1],RAB[I2-1],RAB[I3-1],A1);
_19:
HS := H;
H := H/2.0;
DE92RS (F,M,YX,X,A,H,R1,RAB[0],RAB[I1-1],RAB[I2-1],RAB[I3-1],A1);
DE84RJ (F,X+H,R1,A2,M,EPSJ,RAB[0],RAB[I1-1]);
DE92RS (F,M,R1,X+H,A2,H,YD,RAB[0],RAB[I1-1],RAB[I2-1],
     RAB[I3-1],A1);
H := HS;
for I:=1 to M do
 begin
  RAB[I-1] := (YD[I-1] - R2[I-1])/15.0;
  XT := Abs(RAB[I-1]);
  if ( Abs(YD[I-1]) >= P ) 
   then XT := XT/Abs(YD[I-1]);
  if ( XT > EPS ) 
   then goto _100;
  if ( XT >= EPS1 ) 
   then BULD := False;
_80:
 end;
XP := X;
X := X + H;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_85:
  YX[I-1] := YD[I-1];
 end;
if ( BULD ) 
 then H := H*2.0;
goto _130;
_100:
if ( BULHM ) 
 then goto _110;
H := H/2.0;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _105;
H := Sign(HMIN,H);
BULHM := True;
goto _18;
_105:
for I:=1 to M do
 begin
_106:
  R2[I-1] := R1[I-1];
 end;
goto _19;
_110:
IERR := 65;
UTDE20 (92,IERR);
_130:
JSTART := 1;
end;

end.
